# Contributing to Juicer

:+1::tada: First off, thanks for taking the time to contribute! :tada::+1:

The following is a set of guidelines for contributing to Juicer, which is hosted in the [Aiden Lab Repositories](https://github.com/aidenlab) on GitHub. These are mostly guidelines, not rules. Use your best judgment, and feel free to propose changes to this document in a pull request.

## Code of Conduct

This project and everyone participating in it is governed by the [Code of Conduct](CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Please report unacceptable behavior to [aidenlab@bcm.edu](mailto:aidenlab@bcm.edu).

## I don't want to read this whole thing I just have a question!!!

> **Note:** Please don't file an issue to ask a question. You'll get faster results by using our [3D-Genomics Official Forum](https://aidenlab.org/forum.html). We have an official message board where the community chimes in with helpful advice if you have questions.

While we strongly suggest using the public forum so that the community at large benefits from the discussion, you can also send us an email at [aidenlab@bcm.edu](mailto:aidenlab@bcm.edu) for questions related to sensitive datasets.

## **Did you find a bug?**

* **Ensure the bug was not already reported** by searching on GitHub under [Issues](https://github.com/aidenlab/juicer/issues).

* If you're unable to find an open issue addressing the problem, [open a new one](https://github.com/aidenlab/juicer/issues/new). Be sure to include a **title and clear description**, as much relevant information as possible, and a **code sample, executable test case, or clear set of instructions** demonstrating the expected behavior that is not occurring.

## **Did you write a patch that fixes a bug?**

* Open a new GitHub pull request with the patch.

* Ensure the Pull Request description clearly describes the problem and solution. Include the relevant issue number if applicable.

## **Did you fix whitespace, format code, or make a purely cosmetic patch?**

Changes that are cosmetic in nature and do not add anything to the stability, functionality, or testability of Juicer are still welcome!

## **Do you intend to add a new feature or change an existing one?**

* Suggest your change by creating a Github issue! Reach out to us at [aidenlab@bcm.edu](mailto:aidenlab@bcm.edu) for advice and start writing code!

## **Do you have questions about the source code?**

* Ask any question about how to use Juicer in the [3D Genomics Official Forum](https://aidenlab.org/forum.html).

## **Do you want to contribute to the Juicer documentation?**

* Reach out to us at [aidenlab@bcm.edu](mailto:aidenlab@bcm.edu).

Juicer is a volunteer effort. We encourage you to pitch in and join the team!

Thanks! :heart: :heart: :heart:

The Center for Genome Architecture,
Baylor College of Medicine & Rice University
